	device zxspectrum128
        ORG #8000
 incbin "prime.data"
        ORG #6000
begin
deltax:
	db 1,0,-1,0
deltay:
	db 0,-1,0,1
bw:
	db 128,64,32,16,8,4,2,1

runi:
	xor a
	out ($FE),a
	ld hl,$5800
	ld de,$5801
	ld bc,767
	ld (hl),$47
	ldir

; 
;    x.i=127
;    y.i=95
	ld de,$5F7F;DE=Y.X
;    direction.i=0;1
	ld ixl,0
;    moves.i=1
;    move.i=0
;    moveswitch.i=0

; jr $
loop:

;    Repeat
;      Select direction
;       Case 0;1
;          x=x+1
;        Case 1;2
;          y=y-1
;        Case 2;3
;          x=x-1
;        Case 3;4
;          y=y+1
;      EndSelect
	ld a,ixl
;	add a,a
	ld l,a
	ld h,deltax/256
	ld a,(hl)
	add a,e
	ld e,a
	set 2,l;(hl)=deltay
	ld a,(hl)
	add a,d
	ld d,a

;      move=move+1
;      If move=moves
;        move=0
;        moveswitch=moveswitch+1
;       If moveswitch = 2
;           moveswitch=0;
;           moves=moves+1
;      EndIf
;       direction=(direction+1)&3
;     EndIf

move: ld a,0
		inc a;move=move+1
		ld h,a;.
moves:	cp 1; If move=moves
		jr nz,endif1
		ld h,0;move=0

moveswitch:
	ld a,0
	inc a ; moveswitch=moveswitch+1
	cp 2 ; If moveswitch = 2
	jr nz,endif2

	ld a,(moves+1);moves=moves+1
	inc a
	ld (moves+1),a

	xor a;moveswitch=0;
endif2:
	ld (moveswitch+1),a

	ld a,ixl
	inc a
	and 3
	ld ixl,a

endif1:
	ld a,h
	ld (move+1),a

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       If IsPrime(mo)
;         Box(x,y,1,1,RGB(255,255,255))
;       EndIf
;       mo+1
cnt:
	ld hl,0

	ld a,l
	and 7
	
	srl h:rr l
	srl h:rr l
	srl h:rr l;/8
	ld bc,$8000
	add hl,bc

;bitweight
	or 8
	ld c,a
	ld b,bw/256
	ld a,(bc)
	and (hl)
	jp z,skip_plot
	ld a,d
	cp 192
	jp nc,skip_plot

; Get screen address 
; D = Y pixel position 
; E = X pixel position 
; Returns address in HL 
Get_Pixel_Address:  LD A,D;B          ; Calculate Y2,Y1,Y0 
                    AND %00000111   ; Mask out unwanted bits 
                    OR %01000000    ; Set base address of screen 
                    LD H,A          ; Store in H 
                    LD A,D;B          ; Calculate Y7,Y6 
                    RRA             ; Shift to position 
                    RRA 
                    RRA 
                    AND %00011000   ; Mask out unwanted bits 
                    OR H            ; OR with Y2,Y1,Y0 
                    LD H,A          ; Store in H 
                    LD A,D;B          ; Calculate Y5,Y4,Y3 
                    RLA             ; Shift to position 
                    RLA 
                    AND %11100000   ; Mask out unwanted bits 
                    LD L,A          ; Store in L 
                    LD A,E;C          ; Calculate X4,X3,X2,X1,X0 
                    RRA             ; Shift into position 
                    RRA 
                    RRA 
                    AND %00011111   ; Mask out unwanted bits 
                    OR L            ; OR with Y5,Y4,Y3 
                    LD L,A          ; Store in L 

	ld a,e
	and 7
	inc a
	ld b,a
	xor a
	scf
mm:
	rra
	djnz mm
	or (hl)
	ld (hl),a
skip_plot:

	ld hl,(cnt+1)
	inc hl
	ld (cnt+1),hl


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      Until (x=0)And (y=0)



	ld a,d
	or e
	jp nz,loop
	jr $


end
	display /d,end-begin
	savesna "ulams.sna",runi

